<?php

/**
 * aprueba_fp actions.
 *
 * @package    cobro_coactivo
 * @subpackage aprueba_fp
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class aprueba_fpActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_APRUEBA_FP',
        'CBR_FACILIDAD_PAGO_V',
        'CBR_PROCESO_COACTIVO', 
        'CBR_AVOCA_CONOC',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUACION_PROC'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_facilidad_pago' => 'CBR_APRUEBA_FP'
        ),
        'CBR_PROCESO_COACTIVO,LEFT' =>
        array(
            'id_proceso_coactivo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_AVOCA_CONOC,LEFT' =>
        array(
            'id_avoca_conoc' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_APRUEBA_FP' =>
        array(
            'id_aprueba_fp' => 'id_aprueba_fp',
            'id_facilidad_pago' => 'id_facilidad_pago',
            'no_resolucion' => 'no_resolucion',
            'fecha_resol' => 'fecha_resol',
            //'detalle_plantilla' => 'detalle_plantilla',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto'
        ),
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'id_proceso_coactivo' => 'id_proceso_coactivo',
            'id_avoca_conoc' => 'id_avoca_conoc',
            'fecha_registro' => 'fecha_registro'
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'no_proceso' => 'no_proceso',
            'fecha' => 'fecha_coactivo',
            'id_anhos' => 'id_anhos'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_AVOCA_CONOC' =>
        array(
            'no_auto' => 'no_auto',
            'fecha' => 'fecha_avoca',
            'id_tipo_documento' => 'id_tipo_documento'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_APRUEBA_FP' =>
        array(
            'id_aprueba_fp,a' => array('!=' => array(-1)),
            'id_aprueba_fp,b' => array('=' => array('id_aprueba_fp')),
            'id_facilidad_pago' => array('=' => array('id_facilidad_pago')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'no_proceso' => array('=' => array('no_proceso')),
            'id_anhos' => array('=' => array('id_anhos'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_aprueba_fp'; //identificador de la tabla
    protected $id_names = array('id_aprueba_fp'); //llave primaria
    protected $field_names = array('id_facilidad_pago', 'no_resolucion', 'fecha_resol', 'detalle_plantilla', 'observaciones', 'adjunto'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_APRUEBA_FP'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_aprueba_fp'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {
                $id_aprueba_fp = $list_data_post[0]['id_aprueba_fp'];

                if ($request['id_plantilla'] != "") {
                    $id_plantilla = $request['id_plantilla'];
                    $sql = <<<EOD
UPDATE CBR_APRUEBA_FP SET DETALLE_PLANTILLA=(select detalle from cbr_plantilla where id_plantilla = $id_plantilla) 
    where id_aprueba_fp = $id_aprueba_fp
EOD;


                    $this->conn->execute($sql);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];


            $id_tipo_documento = 1; //RESOLUCION


            $sql = <<<EOD
select consecutivo from cbr_consecutivo_doc where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) > 0) {

                $consecutivo = $records[0]['consecutivo'];

                $request['no_resolucion'] = $consecutivo;

                $sql = <<<EOD
update cbr_consecutivo_doc set consecutivo =($consecutivo+1) where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;

                CN_TABLE::executeSQL($sql);
            } else {

                $request['no_resolucion'] = 1;

                $sql = <<<EOD
Insert into CBR_CONSECUTIVO_DOC (ID_CONSECUTIVO_DOC,ID_TIPO_DOCUMENTO,ID_ANHOS,CONSECUTIVO) values (null,'$id_tipo_documento','$id_anhos','2') 
EOD;

                CN_TABLE::executeSQL($sql);
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        if (!isset($request['detalle_plantilla'])) {
            $request['detalle_plantilla'] = '<br> ';
        } elseif (isset($request['detalle_plantilla']) && $request['detalle_plantilla'] == null) {
            $request['detalle_plantilla'] = '<br> ';
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
